﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ServiceModel;
using System.Text;

namespace Amz
{
    public partial class Page : UserControl
    {
        private const string AWS_AWS_ID = "YOUR AMAZON ACCESS KEY";
        private const string AWS_SECRET_KEY = "YOUR AMAZON SECRET";

        AWS.AmazonS3Client s3;

        public Page()
        {
            InitializeComponent();
            Loaded += new RoutedEventHandler(Page_Loaded);
            BucketList.SelectionChanged += new SelectionChangedEventHandler(BucketList_SelectionChanged);

        }

        void BucketList_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            DateTime timeStamp = S3Helper.GetDatestamp();
            AWS.ListAllMyBucketsEntry lb = BucketList.SelectedItem as AWS.ListAllMyBucketsEntry;
            string bucketName = lb.Name;

            s3.ListBucketCompleted += new EventHandler<AWS.ListBucketCompletedEventArgs>(s3_ListBucketCompleted);
            s3.ListBucketAsync(bucketName, null, null, 1000, null, AWS_AWS_ID, timeStamp, S3Helper.GenerateSignature(AWS_SECRET_KEY, "ListBucket", timeStamp), null, null);
        }

        void s3_ListBucketCompleted(object sender, AWS.ListBucketCompletedEventArgs e)
        {
            AWS.ListBucketResult res = e.Result;
            AWS.ListEntry[] contents = res.Contents;
            BucketContents.ItemsSource = contents;
        }

        void Page_Loaded(object sender, RoutedEventArgs e)
        {
            DateTime timeStamp = S3Helper.GetDatestamp();

            s3 = new AWS.AmazonS3Client();

            s3.ListAllMyBucketsCompleted += new EventHandler<AWS.ListAllMyBucketsCompletedEventArgs>(s3_ListAllMyBucketsCompleted);
            s3.ListAllMyBucketsAsync(AWS_AWS_ID, timeStamp, S3Helper.GenerateSignature(AWS_SECRET_KEY, "ListAllMyBuckets", timeStamp));
        }

        void s3_ListAllMyBucketsCompleted(object sender, AWS.ListAllMyBucketsCompletedEventArgs e)
        {
            if (e.Error == null)
            {
                AWS.ListAllMyBucketsResult res = e.Result;
                AWS.ListAllMyBucketsEntry[] buckets = res.Buckets;
                BucketList.ItemsSource = buckets;
            }
        }
    }
}